【HDU 1059】 Dividing 多重背包问题 DP

Problem Description
Marsha and Bill own a collection of marbles. They want to split the collection among themselves so that both receive an equal share of the marbles. This would be easy if all the marbles had the same value, because then they could just split the collection in half. But unfortunately, some of the marbles are larger, or more beautiful than others. So, Marsha and Bill start by assigning a value, a natural number between one and six, to each marble. Now they want to divide the marbles so that each of them gets the same total value.
Unfortunately, they realize that it might be impossible to divide the marbles in this way (even if the total value of all marbles is even). For example, if there are one marble of value 1, one of value 3 and two of value 4, then they cannot be split into sets of equal value. So, they ask you to write a program that checks whether there is a fair partition of the marbles.

Input
Each line in the input describes one collection of marbles to be divided. The lines consist of six non-negative integers n1, n2, …, n6, where ni is the number of marbles of value i. So, the example from above would be described by the input-line ``1 0 1 2 0 0’’. The maximum total number of marbles will be 20000.

The last line of the input file will be ``0 0 0 0 0 0’’; do not process this line.

Output
For each colletcion, output Collection #k:'', where k is the number of the test case, and then eitherCan be divided.’’ or ``Can’t be divided.’’.

Output a blank line after each test case.

Sample Input
1 0 1 2 0 0
1 0 0 0 1 1
0 0 0 0 0 0

Sample Output
Collection #1:
Can’t be divided.

Collection #2:
Can be divided.

题意:给你1-6枚面值的硬币各若干,问能否均分成两份等价的

思路:

多重背包问题。
1.用dp[i]来表示能否凑到i这么多的硬币(目的为了凑到sum/2)
2.从小到大遍历面值,内层遍历一遍j从1->sum/2,每次拿一枚硬币去铺到j,看能否铺成功。条件就是dp[j]是没有铺到的,且dp[j-i]是要铺到的(因为要从dp[j-i]这个状态转移过来),同时在j-i的时候我当前i剩下的硬币数量要>=1 。状态转移方程如下:

`  rep(i,1,6)
        {
            rep(j,0,sum/2) Left[j] = a[i];  
            rep(j,i,sum/2) if(!dp[j]&&dp[j-i]&&Left[j-i]>=1)    dp[j] = 1, Left[j] = Left[j-i] - 1;
        }`

AC代码:

#include<iostream>
#include<string>
#include<algorithm>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<map>
#include <queue>
#include<sstream>
#include <stack>
#include <set>
#include <bitset>
#include<vector>
#define FAST ios::sync_with_stdio(false)
#define abs(a) ((a)>=0?(a):-(a))
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(),(x).end()
#define mem(a,b) memset(a,b,sizeof(a))
#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))
#define rep(i,a,n) for(int i=a;i<=n;++i)
#define per(i,n,a) for(int i=n;i>=a;--i)
#define pb push_back
#define mp make_pair
#define fi first
#define se second
using namespace std;
typedef long long ll;
typedef pair<ll,ll> PII;
const int maxn = 2e5+200;
const int inf=0x3f3f3f3f;
const double eps = 1e-7;
const double pi=acos(-1.0);
const int mod = 1e9+7;
inline int lowbit(int x){return x&(-x);}
ll gcd(ll a,ll b){return b?gcd(b,a%b):a;}
void ex_gcd(ll a,ll b,ll &d,ll &x,ll &y){if(!b){d=a,x=1,y=0;}else{ex_gcd(b,a%b,d,y,x);y-=x*(a/b);}}//x=(x%(b/d)+(b/d))%(b/d);
inline ll qpow(ll a,ll b,ll MOD=mod){ll res=1;a%=MOD;while(b>0){if(b&1)res=res*a%MOD;a=a*a%MOD;b>>=1;}return res;}
inline ll inv(ll x,ll p){return qpow(x,p-2,p);}
inline ll Jos(ll n,ll k,ll s=1){ll res=0;rep(i,1,n+1) res=(res+k)%i;return (res+s)%n;}
inline int read(){ int f = 1; int x = 0;char ch = getchar();while(ch>'9'|ch<'0') {if(ch=='-') f=-1; ch = getchar();}while(ch>='0'&&ch<='9') x = (x<<3) + (x<<1) + ch - '0',  ch = getchar();return x*f; }
int dir[4][2] = { {1,0}, {-1,0},{0,1},{0,-1} };

int a[10];
int dp[maxn];
int Left[maxn];

int main()
{
    int num = 1;
    while(1)
    {
        rep(i,1,6) a[i] = read();
        if(!(a[1]||a[2]||a[3]||a[4]||a[5]||a[6])) break;
        int sum = 0; mem(dp,0);
        rep(i,1,6) sum += a[i]*i;
         printf("Collection #%d:\n", num++);
        if(sum%2)
        {
             puts("Can't be divided.\n");
            continue;
        }
        dp[0] = 1;
        rep(i,1,6)
        {
            rep(j,0,sum/2) Left[j] = a[i];
            rep(j,i,sum/2) if(!dp[j]&&dp[j-i]&&Left[j-i]>=1)    dp[j] = 1, Left[j] = Left[j-i] - 1;
        }
        if(dp[sum/2])   puts("Can be divided.\n");
        else     puts("Can't be divided.\n");
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/qq_45492531/article/details/107635689